"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenType = void 0;
var TokenType;
(function (TokenType) {
    // Single-character tokens.
    TokenType[TokenType["LEFT_PAREN"] = 0] = "LEFT_PAREN";
    TokenType[TokenType["RIGHT_PAREN"] = 1] = "RIGHT_PAREN";
    TokenType[TokenType["LEFT_BRACE"] = 2] = "LEFT_BRACE";
    TokenType[TokenType["RIGHT_BRACE"] = 3] = "RIGHT_BRACE";
    TokenType[TokenType["COMMA"] = 4] = "COMMA";
    TokenType[TokenType["DOT"] = 5] = "DOT";
    TokenType[TokenType["MINUS"] = 6] = "MINUS";
    TokenType[TokenType["PLUS"] = 7] = "PLUS";
    TokenType[TokenType["SEMICOLON"] = 8] = "SEMICOLON";
    TokenType[TokenType["SLASH"] = 9] = "SLASH";
    TokenType[TokenType["STAR"] = 10] = "STAR";
    // One or two character tokens.
    TokenType[TokenType["GREATER"] = 11] = "GREATER";
    TokenType[TokenType["GREATER_EQUAL"] = 12] = "GREATER_EQUAL";
    TokenType[TokenType["LESS"] = 13] = "LESS";
    TokenType[TokenType["LESS_EQUAL"] = 14] = "LESS_EQUAL";
    // One or two or three character tokens
    TokenType[TokenType["BANG"] = 15] = "BANG";
    TokenType[TokenType["BANG_EQUAL"] = 16] = "BANG_EQUAL";
    TokenType[TokenType["BANG_EQUAL_EQUAL"] = 17] = "BANG_EQUAL_EQUAL";
    TokenType[TokenType["EQUAL"] = 18] = "EQUAL";
    TokenType[TokenType["EQUAL_EQUAL"] = 19] = "EQUAL_EQUAL";
    TokenType[TokenType["EQUAL_EQUAL_EQUAL"] = 20] = "EQUAL_EQUAL_EQUAL";
    // Literals
    TokenType[TokenType["IDENTIFIER"] = 21] = "IDENTIFIER";
    TokenType[TokenType["STRING"] = 22] = "STRING";
    TokenType[TokenType["NUMBER"] = 23] = "NUMBER";
    // Keywords.
    TokenType[TokenType["AND"] = 24] = "AND";
    TokenType[TokenType["CLASS"] = 25] = "CLASS";
    TokenType[TokenType["ELSE"] = 26] = "ELSE";
    TokenType[TokenType["FALSE"] = 27] = "FALSE";
    TokenType[TokenType["FUN"] = 28] = "FUN";
    TokenType[TokenType["FOR"] = 29] = "FOR";
    TokenType[TokenType["IF"] = 30] = "IF";
    TokenType[TokenType["NIL"] = 31] = "NIL";
    TokenType[TokenType["OR"] = 32] = "OR";
    TokenType[TokenType["PRINT"] = 33] = "PRINT";
    TokenType[TokenType["RETURN"] = 34] = "RETURN";
    TokenType[TokenType["SUPER"] = 35] = "SUPER";
    TokenType[TokenType["THIS"] = 36] = "THIS";
    TokenType[TokenType["TRUE"] = 37] = "TRUE";
    TokenType[TokenType["VAR"] = 38] = "VAR";
    TokenType[TokenType["WHILE"] = 39] = "WHILE";
    TokenType[TokenType["NULL"] = 40] = "NULL";
    TokenType[TokenType["UNDEFINED"] = 41] = "UNDEFINED";
    TokenType[TokenType["EOF"] = 42] = "EOF";
})(TokenType = exports.TokenType || (exports.TokenType = {}));
class Token {
    type;
    lexeme;
    literal;
    line;
    constructor(type, lexeme, literal, line) {
        this.type = type;
        this.lexeme = lexeme;
        this.literal = literal;
        this.line = line;
    }
    toString() {
        return this.type + " " + this.lexeme + " " + this.literal;
    }
}
exports.default = Token;
